#include "globus_common.h"
#include <stdio.h>

extern void
globus_i_module_dump(
    FILE *				out_f);

globus_bool_t
module1_activate(void);

globus_bool_t
module1_deactivate(void);

void
module1_atexit(void);

globus_bool_t
module2_activate(void);

globus_bool_t
module2_deactivate(void);

void
module2_atexit(void);

globus_bool_t
module3_activate(void);

globus_bool_t
module3_deactivate(void);

void
module3_atexit(void);

static globus_module_descriptor_t module1 =
{
    "Module1",
    module1_activate,
    module1_deactivate,
    module1_atexit
};

static globus_module_descriptor_t module2 =
{
    "Module2",
    module2_activate,
    module2_deactivate,
    module2_atexit
};

static globus_module_descriptor_t module3 =
{
    "Module3",
    module3_activate,
    module3_deactivate,
    module3_atexit
};


int
main(
    int					argc,
    char *				argv[])
{
    int					rc;
    
    rc = globus_module_deactivate(GLOBUS_COMMON_MODULE);
    fprintf(stderr, "activated globus_common\n");
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);
    
    rc = globus_module_activate(GLOBUS_COMMON_MODULE);
    fprintf(stderr, "activated globus_common\n");
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);
    
    fprintf(stderr, "activating module1\n");
    rc = globus_module_activate(&module1);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);
    
    fprintf(stderr, "activating module2\n");
    rc = globus_module_activate(&module2);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);

    fprintf(stderr, "activating module3\n");
    rc = globus_module_activate(&module3);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);

    fprintf(stderr, "deactivating module3\n");
    rc = globus_module_deactivate(&module3);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);
    
    fprintf(stderr, "activating module3\n");
    rc = globus_module_activate(&module3);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);

    fprintf(stderr, "deactivating module1\n");
    rc = globus_module_deactivate(&module1);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);

    fprintf(stderr, "deactivating module2\n");
    rc = globus_module_deactivate(&module2);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);

    fprintf(stderr, "deactivating module3\n");
    rc = globus_module_deactivate(&module3);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);

    fprintf(stderr, "activating module1\n");
    rc = globus_module_activate(&module1);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);
    
    fprintf(stderr, "deactivating all modules\n");
    rc = globus_module_deactivate_all();
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);

    fprintf(stderr, "deactivating globus_common\n");
    rc = globus_module_deactivate(GLOBUS_COMMON_MODULE);
    fprintf(stderr, "rc=%d\n", rc);
    globus_i_module_dump(stderr);
    
    fprintf(stderr, "about to return 0\n");
    return(0);
}


globus_bool_t
module1_activate(void)
{
    fprintf(stderr, "module1_activate()\n");
    globus_module_activate(&module2);
    return GLOBUS_SUCCESS;
}

globus_bool_t
module1_deactivate(void)
{
    fprintf(stderr, "module1_deactivate()\n");
    globus_module_deactivate(&module2);
    return GLOBUS_SUCCESS;
}

void
module1_atexit(void)
{
    fprintf(stderr, "module1_atexit()\n");
    globus_i_module_dump(stderr);
}

globus_bool_t
module2_activate(void)
{
    fprintf(stderr, "module2_activate()\n");
    globus_module_activate(&module3);
    return GLOBUS_SUCCESS;
}

globus_bool_t
module2_deactivate(void)
{
    fprintf(stderr, "module2_deactivate()\n");
    globus_module_deactivate(&module3);
    return GLOBUS_SUCCESS;
}

void
module2_atexit(void)
{
    fprintf(stderr, "module2_atexit()\n");
}

globus_bool_t
module3_activate(void)
{
    fprintf(stderr, "module3_activate()\n");
    return GLOBUS_SUCCESS;
}

globus_bool_t
module3_deactivate(void)
{
    fprintf(stderr, "module3_deactivate()\n");
    return GLOBUS_SUCCESS;
}

void
module3_atexit(void)
{
    fprintf(stderr, "module3_atexit()\n");
}

