/******************************************************************************
Description:

  Top level CIF include file

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Comm.H,v $
  $Date: 1998/09/28 20:16:22 $
  $Revision: 1.6 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#if !defined(CIF_INCLUDE_COMM)
#define CIF_INCLUDE_COMM 1

/******************************************************************************
			Include necessary header files
******************************************************************************/
#include "CIF_Toolkit.H"
#include "CIF_Comm_Status.H"
#include "CIF_Comm_Message.H"
#include "CIF_I_Comm_Properties.H"
#include "CIF_Comm_Connection.H"
#include "CIF_Comm_Listener.H"
#include "CIF_Comm_Factory.H"

#include "globus_common.h"

/******************************************************************************
			     Define CIF constants
******************************************************************************/
#define CIF_COMM_PROTOCOL_TCP_STR	"x-cif-tcp"
#define CIF_COMM_PROTOCOL_UDP_STR	"x-cif-udp"
#define CIF_COMM_PROTOCOL_UUM_STR	"x-cif-uum"
#define CIF_COMM_PROTOCOL_ROM_STR	"x-cif-rom"


/******************************************************************************
			       Define CIF types
******************************************************************************/
class
CIF_Comm
{
    public: static
    CIF_Bool
    activate();

    public: static
    void
    poll();
    
    public: static
    CIF_Bool
    deactivate();

    private: static
    int
    l_activate();

    private: static
    int
    l_deactivate();

    private: static
    int
    l_handle_Fault(
	void *					user_arg,
	int					fault_code);
    
    public:
    static CIF_Comm_Status			status;

    private: static
    globus_module_descriptor_t			l_module_descriptor;
};


#endif /* CIF_INCLUDE_COMM */
